%define __libtoolize /bin/true
%define __cputoolize /bin/true

%define official_branding 1

%define build_bundled_lightning 0

%define release %mkrel 1

%if %{official_branding}
%define title Mozilla Thunderbird
%else
%define title Mail/News
%endif

%define oname thunderbird
%define tb_appid \{3550f703-e582-4d05-9a08-453d09bdfdc6\}
%define tbdir %{_libdir}/%{oname}-%{version}
%define tbextdir %{_libdir}/mozilla/extensions/%{tb_appid}

%define xpi 0
%define enigmail_version 1.1.2
%define enigmail_short_version 1.1.2
%define enigmail_id \{847b3a00-7ab1-11d4-8f02-006008948af5\}

%define _provides_exceptions libgtkembedmoz.so\\|libxpcom.so
%define _requires_exceptions libgtkembedmoz.so\\|libxpcom.so

# FIXME: Bug in nsExtensionManager.js prevents using x86_64 as arch
# FIXME: I tried to modify nsExtensionManager.js.in, but it
# FIXME: complained that I had modified it
%ifarch %{ix86}
%define tbarch x86
%else # ix86
%ifarch x86_64
%define tbarch %{_arch}
%else # x86_64
%define tbarch %{_arch}
%endif # x86_64
%endif # ix86

# this seems fragile, so require the exact version or later (#58754)
%define sqlite3_version %(pkg-config --modversion sqlite3 &>/dev/null && pkg-config --modversion sqlite3 2>/dev/null || echo 0)
# this one as well (#59759)
%define nss_libname %mklibname nss 3
%define nss_version %(pkg-config --modversion nss &>/dev/null && pkg-config --modversion nss 2>/dev/null || echo 0)

Name:		mozilla-thunderbird
Version:	3.1.18
Release:	%{release}
Epoch:		0
Summary:	Full-featured email, RSS, and newsgroup client
License:	MPL
Group:		Networking/Mail
URL:		http://www.mozillamessaging.com/
Source0:        http://ftp.mozilla.org/pub/mozilla.org/thunderbird/releases/%{version}/source/thunderbird-%{version}.source.tar.bz2
Source12:       mozilla-thunderbird-mageia-default-prefs.js
Source30:       mozilla-thunderbird-open-browser.sh
Source31:       mozilla-thunderbird-open-browser-xdg.sh
# Mandriva sources (Source300+)
Source300:      http://www.mozilla-enigmail.org/download/source/enigmail-%{enigmail_version}.tar.gz
Source301:      http://www.mozilla-enigmail.org/download/source/enigmail-%{enigmail_version}.tar.gz.asc
Source302:      %{name}-icons.tar.bz2
Source303:      mozilla-thunderbird-unofficial.png
# Language package template
Source400:	mozilla-thunderbird-enigmail-l10n-template.in
# Build patches
Patch2:         mozilla-firefox-1.0-prdtoa.patch
Patch3:		mozilla-thunderbird-2.0.0.19-fix-str-fmt.patch
%if %{build_bundled_lightning}
Patch4:		mozilla-thunderbird-3.1.7-enable-lightning.patch
%endif
# Debian patches (Patch200+)
Patch200:       mozilla-thunderbird-gtk-settings.patch
Patch212:       mozilla-thunderbird-enigmail-ui-content-contents-rdf.patch
Patch213:       mozilla-thunderbird-enigmail-build-package-contents-rdf.patch
Patch215:	mozilla-thunderbird-enigmail-visibility.patch
# Mandriva patches (Patch300+)
Patch300:       mozilla-thunderbird-0.8-progname.patch
Patch301:       mozilla-thunderbird-enigmail-package.patch
Patch302:       mozilla-thunderbird-check-default-mailer.patch
Patch304:       mozilla-thunderbird-run-mozilla.patch
Patch305:	mozilla-thunderbird-2.0b1-x11libs.patch
Patch306:       mozilla-thunderbird-run-mozilla-soundwrapper.patch
Patch307:       mozilla-thunderbird-system-hunspell.patch
# Adds support for config file thunderbird.cfg
Patch310:	thunderbird-2.0b2-configfile.patch
Patch334:	mozilla-thunderbird-2.0.0.22-CVE-2009-XXXX.diff
Patch335:	thunderbird-3.0rc1-format-not-a-string-literal.patch
Patch336:	mozilla-thunderbird-CVE-2009-3560.diff
# fix for CVE-2011-3640
# taken from upstream: https://bugzilla.mozilla.org/show_bug.cgi?id=641052#c6
Patch337:	fix-CVE-2011-3640.patch
# OpenSuse patches (Patch400+)
Patch400:	thunderbird-appname.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	autoconf2.1
BuildRequires:	cairo-devel >= 1.8.8
Requires:	%{mklibname sqlite3_ 0} >= %{sqlite3_version}
BuildRequires:	libsqlite3-devel >= 3.6.22
Requires:	%{nss_libname} >= 2:%{nss_version}
BuildRequires:  gtk2-devel
BuildRequires:  gzip
BuildRequires:	python-devel
BuildRequires:  libgnome2-devel
BuildRequires:  libgnomeui2-devel
BuildRequires:  libgnome-vfs2-devel
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel >= 1.2.25-2
BuildRequires:  nspr-devel >= 2:4.8.4
BuildRequires:  nss-devel >= 2:3.12.6
BuildRequires:  nss-static-devel
BuildRequires:  unzip
BuildRequires:  zip
BuildRequires:	zlib-devel
BuildRequires:	libIDL-devel
# Needed by xmlterm (not built) and unused enigmail scripts
#BuildRequires:	tcsh
BuildRequires:	freetype2-devel
BuildRequires:	xft2-devel
BuildRequires:	libxt-devel
BuildRequires:	hunspell-devel
# fixes bug 46107
Requires(post):	desktop-file-utils
Requires(postun): desktop-file-utils
Requires(post):	mktemp
Requires(post): rpm-helper
Requires(postun): rpm-helper
# Integrates thunderbird with xdg-utils.
Requires: xdg-utils
%if %{official_branding}
BuildRequires:	imagemagick
%endif
# Thunderbird 3 requires alsa
BuildRequires:	libalsa-devel
BuildRequires:	python
BuildRequires:	libnotify-devel
BuildRequires:	libiw-devel
# conflict with mozilla-thunderbird-lightning <= 1.3.9, now lightning is built
# from its own src.rpm
Conflicts:	mozilla-thunderbird-lightning <= 1.3.9

%description
%{title} is a full-featured email, RSS and newsgroup client that
makes emailing safer, faster and easier than ever before.

#===============================================================================

%package enigmail
Summary:        Access the authentication and encryption features provided by GnuPG
Group:          Networking/Mail
Requires:       %{name} = %{epoch}:%{version}
Obsoletes:      %{name}-enigmime
Provides:       %{name}-enigmime = %{epoch}:%{version}
Requires:       gnupg
Requires(post): %{name} = %{epoch}:%{version}
Requires(preun): %{name} = %{epoch}:%{version}
Requires(post):	mktemp
Requires(postun): mktemp
# Bug #35180
Suggests:	pinentry-gtk

%description enigmail
Enigmail is an extension to the mail client of %{title}
which allows users to access the authentication and encryption
features provided by GnuPG.

Main Features

    * Encrypt/sign mail when sending, decrypt/authenticate received
      mail
    * Support for inline-PGP (RFC 2440) and PGP/MIME (RFC 3156)
    * Per-Account based encryption and signing defaults
    * Per-Recipient rules for automated key selection, and
      enabling/disabling encryption and signing
    * OpenPGP key management interface

#===============================================================================

%package -n nsinstall
Summary:        Netscape portable install command
Group:          Development/Other

%description -n nsinstall
Netscape portable install command.

#===============================================================================
%if %{build_bundled_lightning}
%package lightning
Summary:	Calendar extension for Thunderbird
URL:		http://www.mozilla.org/projects/calendar/lightning/
Requires:	%{name} >= %{epoch}:%{version}

%description lightning
Calendar extension for Thunderbird.
%endif
#===============================================================================
# enigmail-l10n
# Supported l10n language lists
%define l10n_langlist	ar ca cs de el es fi fr hu it ja ko nb nl pl pt pt_BR ru sl sv tr vi zh_CN zh_TW

# Disabled l10n languages, for any reason
# nl sk es_AR do not support 0.95.0 yet
#define disabled_l10n_langlist	nl sk es_AR ro
%define disabled_l10n_langlist %{nil}

# Language descriptions
%define language_ar ar
%define langname_ar Arabic
%define language_ca ca
%define langname_ca Catalan
%define language_cs cs-CZ
%define langname_cs Czech
%define language_de de-DE
%define langname_de German
%define language_el el
%define langname_el Greek
%define language_es_AR es-AR
%define langname_es_AR Spanish (Argentina)
%define language_es es-ES
%define langname_es Spanish
%define language_fi fi-FI
%define langname_fi Finnish
%define language_fr fr-FR
%define langname_fr French
%define language_hu hu-HU
%define langname_hu Hungarian
%define language_it it-IT
%define langname_it Italian
%define language_ja ja-JP
%define langname_ja Japanese
%define language_ko ko-KR
%define langname_ko Korean
%define language_nb nb-NO
%define langname_nb Norwegian Bokmaal
%define langname_nl Dutch
%define language_nl nl-NL
%define language_pl pl-PL
%define langname_pl Polish
%define langname_pt Portuguese
%define language_pt pt-PT
%define language_pt_BR pt-BR
%define langname_pt_BR Brazilian portuguese
%define language_ro ro-RO
%define langname_ro Romanian
%define language_ru ru-RU
%define langname_ru Russian
%define language_sk sk-SK
%define langname_sk Slovak
%define language_sl sl-SI
%define langname_sl Slovenian
%define language_sv sv-SE
%define langname_sv Swedish
%define language_tr tr-TR
%define langname_tr Turkish
%define language_vi vi-VN
%define langname_vi Vietnamese
%define language_zh_CN zh-CN
%define langname_zh_CN Simplified Chinese
%define language_zh_TW zh-TW
%define langname_zh_TW Traditional Chinese

# --- Danger line ---

# All langs
%{expand:%%define langlist %(for lang in %l10n_langlist; do echo "$lang"; done | sort -u | sed ':a;$!N;s/\n/ /;ta')}

# Defaults (all languages enabled by default)
# l10n
%{expand:%(for lang in %l10n_langlist; do echo "%%define l10n_$lang 1"; done)}
%{expand:%(for lang in %disabled_l10n_langlist; do echo "%%define l10n_$lang 0"; done)}

# Params
%{expand:%(for lang in %langlist; do echo "%%bcond_without $lang"; done)}

# Locales
%{expand:%(for lang in %l10n_langlist; do echo "%%define locale_$lang `echo $lang | cut -d _ -f 1` "; done)}

# Expand all languages packages.
%{expand:%(\
	for lang in %langlist; do\
		echo "%%{expand:%%(sed "s!__LANG__!$lang!g" %{_sourcedir}/mozilla-thunderbird-enigmail-l10n-template.in 2> /dev/null)}";\
	done\
	)
}
#===============================================================================

%prep
%setup -q -c -n %{name}-%{version}

#===================
# Thunderbird itself
%setup -q -T -D -n %{name}-%{version}/comm-1.9.2

%patch2 -p0
%patch3 -p0

%if %{build_bundled_lightning}
%patch4 -p0 -b .enable-lightning
%endif

%patch200 -p1

%patch300 -p0 -b .progname
%patch301 -p1 -b .enigmailpackage
%patch302 -p1 -b .check
%patch304 -p0 -b .run-mozilla
%patch305 -p1 -b .x11libs
%patch307 -p1 -b .system-hunspell

#%%if %{mdkversion} < 201000
#%%patch306 -p0 -b .run-mozilla-soundwrapper
#%%endif

%patch310 -p1

%patch334 -p0 -b .CVE-2009-XXXX
%patch335 -p1 -b .literal
%patch336 -p0 -b .CVE-2009-3560
%patch337 -p0 -b .CVE-2011-3640

%patch400 -p1 -b .appname

#===============================================================================
# Enigmail
%setup -q -T -D -n %{name}-%{version}/comm-1.9.2/mozilla/extensions -a300
%if 0
%patch212 -p2 -b .enigmail-ui-content-contents-rdf
%patch213 -p2 -b .enigmail-build-package-contents-rdf
%endif
%patch215 -p2 -b .enigmail-visibility

%if !%{official_branding}
%setup -q -T -D -n %{name}-%{version}/comm-1.9.2 -a302
%endif

%setup -q -T -D -n %{name}-%{version}/comm-1.9.2

#===============================================================================

%build
export BUILD_OFFICIAL=1
export MOZILLA_OFFICIAL=1

#(tpg) please see bug #32024
# from fedora: Pragma visibility is broken on most platforms for some reason.
#              See http://gcc.gnu.org/bugzilla/show_bug.cgi?id=20297
export ac_cv_visibility_pragma=no

CFLAGS=$(echo %optflags | %{__sed} -e 's/-fexceptions//')
CFLAGS="$CFLAGS -fno-strict-aliasing"
CXXFLAGS="$CFLAGS"
RPM_OPT_FLAGS="$CFLAGS"
export CFLAGS
export CXXFLAGS
export RPM_OPT_FLAGS

autoconf-2.13
%configure2_5x \
    --enable-application=mail \
    --with-system-nspr \
    --with-system-nss \
    --with-system-jpeg \
    --with-system-zlib \
    --enable-system-png \
    --with-pthreads \
    --disable-tests \
    --disable-debug \
    --disable-installer \
    --enable-xinerama \
    --enable-default-toolkit=cairo-gtk2 \
    --disable-xprint \
    --disable-strip \
    --enable-pango \
    --enable-system-cairo \
    --enable-svg \
    --enable-canvas \
    --enable-crypto \
    --enable-extensions=default,inspector \
    --enable-mathml \
    --enable-system-hunspell \
    --enable-calendar \
    --disable-crashreporter \
    --enable-static \
    --disable-libxul \
    --disable-dbus \
    --enable-system-sqlite \
    --enable-system-hunspell \
    --enable-official-branding \
    --with-distribution-id=org.mageia \
    --disable-updater

# Fix ABI for thunderbird and enigmail
%{__perl} -pi -e 's|^TARGET_XPCOM_ABI =.*|TARGET_XPCOM_ABI = %{tbarch}-gcc3|' config/autoconf.mk
%{__perl} -pi -e 's|^ENIG_XPCOM_ABI =.*|ENIG_XPCOM_ABI = Linux_%{tbarch}-gcc3|' extensions/enigmail/Makefile

# Compress jars
%{__perl} -pi -e 's|\-0|\-9|g' config/make-jars.pl

%make

#===============================================================================

pushd mozilla/extensions/enigmail

for i in `find . -type f -name Makefile.in`; do
    if [ -f $i.bak ]; then
        cp $i.bak $i
    else
        %{__cp} $i $i.bak
    fi
#    %{__perl} -pi -e 's|^(DEPTH.*= )../|\1|;' $i
done

./makemake -r
%{make} LOCAL_INCLUDES+="-I\$(DEPTH)/mailnews/mime/src -I../build -I../src -I../ipc/src"

(cd lang
 %{__perl} -pi -e 's|es-AR/enigmail.properties|es-ES/enigmail.properties|' jar.mn
 echo 'zh-TW' >> current-languages.txt
 %{make} LOCAL_INCLUDES+="-I\$(DEPTH)/mailnews/mime/src -I../build -I../src -I../ipc/src"
 for i in `cat current-languages.txt`; do
   ./make-lang.sh $i %{enigmail_short_version}
 done
)

%{make} xpi

popd

#===============================================================================

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}{%{_libdir},%{_bindir},%{_datadir}/applications}
%{__mkdir_p} %buildroot%tbdir


rm -f extensions/spellcheck/locales/en-US/hunspell/en-US.{dic,aff}

make install DESTDIR=%{buildroot} -j ${NRPROC:-1}

rm -rf %buildroot%tbdir/dictionaries
ln -s /usr/share/dict/mozilla %buildroot%tbdir/dictionaries

## Compatibility links for now. #29128
#ln -s %{_libdir}/%{oname}-%{version} \
#	%{buildroot}%{_libdir}/mozilla-thunderbird-%{version}
#ln -s %{_bindir}/%{oname}-config \
#	%{buildroot}%{_bindir}/mozilla-thunderbird-config

%if %{official_branding}
%{__install} -p -D %{buildroot}/%{tbdir}/chrome/icons/default/default256.png %{buildroot}%{_datadir}/pixmaps/%{name}.png
%else
%{__install} -p -D %{SOURCE302} %{buildroot}%{_datadir}/pixmaps/%{name}.png
%endif

cat << EOF > %{buildroot}/%{_datadir}/applications/%_real_vendor-%{name}.desktop
[Desktop Entry]
Version=1.0
Name=%{title}
GenericName=Mail/News
Comment=Mail and News Client
Exec=%{name}
Icon=mozilla-thunderbird
Terminal=false
Type=Application
StartupWMClass=Thunderbird-bin
Categories=GTK;Network;News;Email;X-MandrivaLinux-CrossDesktop;
EOF

# set up the thunderbird start script
(cd %{buildroot}%{_bindir} && %{__ln_s} thunderbird %{name})

%{__perl} -pi -e 's|^moz_libdir=.*|moz_libdir=%{tbdir}|' %{buildroot}/%{_bindir}/thunderbird
%{__perl} -pi -e 's|^MRE_HOME=.*|MRE_HOME=%{tbdir}|' %{buildroot}/%{_bindir}/thunderbird

# <mrl> 200800 is safe here.
# For backwards compatibility with old profiles. Bug #37528
%{__install} -m 755 %{SOURCE31} %{buildroot}/%{tbdir}/open-browser.sh
# For new profiles
%define COMMAND /usr/bin/xdg-open

%{__cat} %{SOURCE12} | %{__perl} -p -e 's,THUNDERBIRD_RPM_VR,%{version}-%{release},g;' \
                                    -e 's,THUNDERBIRD_VENDOR_COMMENT,%{mandriva_release},g;' \
                                    -e 's,COMMAND,%{COMMAND},g' \
  > %{buildroot}/mga-default-prefs
%{__cp} -a %{buildroot}/mga-default-prefs %{buildroot}/%{tbdir}/greprefs/all-mandriva.js
%{__cp} -a %{buildroot}/mga-default-prefs %{buildroot}/%{tbdir}/defaults/pref/all-mandriva.js
%{__rm} -f %{buildroot}/mga-default-prefs

#===============================================================================

# icons
%{__mkdir_p} %{buildroot}{%{_liconsdir},%{_iconsdir},%{_miconsdir}}
%if %{official_branding}
%{__mkdir_p} %{buildroot}%{_datadir}/icons/hicolor/{16x16,22x22,24x24,32x32,48x48,256x256}/apps
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default48.png %{buildroot}%{_liconsdir}/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default32.png %{buildroot}%{_iconsdir}/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default16.png %{buildroot}%{_miconsdir}/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default16.png %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default22.png %{buildroot}%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default24.png %{buildroot}%{_datadir}/icons/hicolor/24x24/apps/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default32.png %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default48.png %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{__install} -m 644 %{buildroot}/%{tbdir}/chrome/icons/default/default256.png %{buildroot}%{_datadir}/icons/hicolor/256x256/apps/%{name}.png
%else
%{__mkdir_p} %{buildroot}%{_datadir}/icons/hicolor/{64x64,128x128}/apps
%{__install} -m 644 %{name}-48.png %{buildroot}%{_liconsdir}/%{name}.png
%{__install} -m 644 %{name}-32.png %{buildroot}%{_iconsdir}/%{name}.png
%{__install} -m 644 %{name}-16.png %{buildroot}%{_miconsdir}/%{name}.png
# Converting up, but not a big issue now that we have official branding
%{_bindir}/convert %{name}-48.png -resize 128x128 %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
%{_bindir}/convert %{name}-48.png -resize 64x64 %{buildroot}%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
%endif

#===============================================================================

#pushd dist
#%{__mkdir_p} %{buildroot}%{_includedir}/%{oname}-%{version}
#%{__cp} -aL include/* %{buildroot}%{_includedir}/%{oname}-%{version}
#%{__mkdir_p} %{buildroot}%{_datadir}/idl/%{oname}-%{version}
#%{__cp} -aL idl/* %{buildroot}%{_datadir}/idl/%{oname}-%{version}
#popd

#pushd dist/sdk
#%{__mkdir_p} %{buildroot}%{_libdir}/%{oname}-%{version}
#%{__cp} -aL bin/* %{buildroot}%{_libdir}/%{oname}-%{version}
#%{__mkdir_p} %{buildroot}%{_includedir}/%{oname}-%{version}
#%{__cp} -aL include/* %{buildroot}%{_includedir}/%{oname}-%{version}
#%{__mkdir_p} %{buildroot}%{_datadir}/idl/%{oname}-%{version}
#%{__cp} -aL idl/* %{buildroot}%{_datadir}/idl/%{oname}-%{version}
#popd

#===============================================================================

%{__mkdir_p} %{buildroot}%{tbextdir}/%{enigmail_id}
%if !%{xpi}
%{_bindir}/unzip -q mozilla/dist/bin/enigmail-%{enigmail_short_version}-linux-*.xpi -d %{buildroot}%{tbextdir}/%{enigmail_id}
%{__chmod} 644 %{buildroot}%{tbextdir}/%{enigmail_id}/chrome.manifest
%else
%{__cp} -aL mozilla/dist/bin/enigmail-%{enigmail_short_version}-linux-*.xpi %{buildroot}%{tbextdir}/%{enigmail_id}/%{enigmail_id}.xpi
%endif

#==============================================================================
#enigmail lang package
# Convert rpm macros to bash variables
%{expand:%(for lang in %langlist; do echo "language_$lang=%%{language_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "with_$lang=%%{with $lang}"; done)}
%{expand:%(for lang in %l10n_langlist; do echo "l10n_$lang=%%{l10n_$lang}"; done)}
pushd mozilla/extensions/enigmail/lang
 for lang in %langlist; do
    %{__mkdir_p} %{buildroot}%{_datadir}/mozilla/extensions/%{tb_appid}/enigmail-$lang@enigmail.mozdev.org
    language="language_$lang"
    language=${!language}
    %{_bindir}/unzip -q enigmail-${language}-%{enigmail_short_version}.xpi -d %{buildroot}%{_datadir}/mozilla/extensions/%{tb_appid}/enigmail-$lang@enigmail.mozdev.org/
 done
popd

#===============================================================================
%if %{build_bundled_lightning}
# lightning ext here
pushd mozilla/dist/xpi-stage/
  for ext in {calendar-timezones,gdata-provider,lightning}; do
    hash="$(sed -n '/^    <em:id>\(.*\)<\/em:id>.*/{s//\1/p;q}' $ext/install.rdf)"
    mkdir -p %buildroot%{tbextdir}/$hash
    %{_bindir}/unzip -q $ext.xpi -d %buildroot%{tbextdir}/$hash/
  done
popd
%endif
#===============================================================================

touch %{buildroot}%{tbdir}/chrome/app-chrome.manifest
%{__chmod} 644 %{buildroot}%{tbdir}/chrome/app-chrome.manifest
touch %{buildroot}%{tbdir}/components/compreg.dat
%{__chmod} 644 %{buildroot}%{tbdir}/components/compreg.dat
touch %{buildroot}%{tbdir}/components/xpti.dat
%{__chmod} 644 %{buildroot}%{tbdir}/components/xpti.dat

#===============================================================================

# remove files already packaged as system libs
#%{__chmod} 644 %{buildroot}%{tbdir}/defaults/pref/enigmail.js
#%{__chmod} 644 %{buildroot}%{tbdir}/extensions/*/defaults/pref*/enigmail.js
#%{__perl} -pi -e 's|agentPath",""|agentPath","%{_bindir}/gpg"|' %{buildroot}%{tbdir}/extensions/*/defaults/pref*/enigmail.js

%{__cp} -aL mozilla/dist/bin/nsinstall %{buildroot}%{_bindir}

#===============================================================================

mkdir -p %{buildroot}%{_sysconfdir}
cat << EOF > %{buildroot}/%{_sysconfdir}/thunderbird.cfg
pref("network.protocol-handler.app.http", "/usr/bin/xdg-open");
pref("network.protocol-handler.app.https", "/usr/bin/xdg-open");
pref("network.protocol-handler.app.ftp", "/usr/bin/xdg-open");
EOF
ln -s %{_sysconfdir}/thunderbird.cfg \
	%{buildroot}%{tbdir}/thunderbird.cfg

#==============================================================================

%clean
%{__rm} -rf %{buildroot}

#===============================================================================

%pre
if [ $1 == 2 ]; then
  if [ -d %{tbdir}/dictionaries ]; then
    # Otherelse rpm can't switch this into a symlink :(
    rm -rf %{tbdir}/dictionaries
  fi
fi

%post
%create_ghostfile %{tbdir}/chrome/app-chrome.manifest root root 644
%create_ghostfile %{tbdir}/components/compreg.dat root root 644
%create_ghostfile %{tbdir}/components/xpti.dat root root 644

if [ -f %{tbdir}/components/compreg.dat ]; then
    %{__rm} -f %{tbdir}/components/compreg.dat
fi

if [ -f %{tbdir}/components/xpti.dat ]; then
    %{__rm} -f %{tbdir}/components/xpti.dat
fi

mktemp="/bin/mktemp -d -q -p /tmp -t %{name}.XXXXXXXXXX"

TMPDIR= TB_TMPDIR=`$mktemp` && {
    HOME="$TB_TMPDIR" LD_LIBRARY_PATH="%{tbdir}" %{tbdir}/thunderbird-bin -nox -register
    test -d "$TB_TMPDIR" && %{__rm} -rf -- "$TB_TMPDIR"
}

#===============================================================================

%post enigmail
if [ -f %{tbdir}/components/compreg.dat ]; then
    %{__rm} -f %{tbdir}/components/compreg.dat
fi

if [ -f %{tbdir}/components/xpti.dat ]; then
    %{__rm} -f %{tbdir}/components/xpti.dat
fi

mktemp="/bin/mktemp -d -q -p /tmp -t %{name}.XXXXXXXXXX"

TMPDIR= TB_TMPDIR=`$mktemp` && {
%if %{xpi}
    HOME="$TB_TMPDIR" LD_LIBRARY_PATH="%{tbdir}" %{tbdir}/thunderbird-bin -nox -install-global-extension %{tbextdir}/enigmail-%{enigmail_version}-linux-*.xpi
%endif
    HOME="$TB_TMPDIR" LD_LIBRARY_PATH="%{tbdir}" %{tbdir}/thunderbird-bin -nox -register
    test -d "$TB_TMPDIR" && %{__rm} -rf -- "$TB_TMPDIR"
}

%preun enigmail
if [ -f %{tbdir}/components/compreg.dat ]; then
    %{__rm} -f %{tbdir}/components/compreg.dat
fi

if [ -f %{tbdir}/components/xpti.dat ]; then
    %{__rm} -f %{tbdir}/components/xpti.dat
fi

if [ -x %{tbdir}/thunderbird-bin ]; then 
mktemp="/bin/mktemp -d -q -p /tmp -t %{name}.XXXXXXXXXX"

  TMPDIR= TB_TMPDIR=`$mktemp` && {
  %if %{xpi}
      HOME="$TB_TMPDIR" LD_LIBRARY_PATH="%{tbdir}" %{tbdir}/thunderbird-bin -nox -install-global-extension %{tbextdir}/enigmail-%{enigmail_version}-linux-*.xpi
  %endif
      HOME="$TB_TMPDIR" LD_LIBRARY_PATH="%{tbdir}" %{tbdir}/thunderbird-bin -nox -register
      test -d "$TB_TMPDIR" && %{__rm} -rf -- "$TB_TMPDIR"
  }
fi

#===============================================================================

%files
%defattr(-,root,root,-)
%doc mozilla/LEGAL
%attr(755,root,root) %{_bindir}/mozilla-thunderbird
%attr(755,root,root) %{_bindir}/thunderbird
%attr(644,root,root) %{_datadir}/applications/*.desktop
%attr(644,root,root) %{_datadir}/pixmaps/%{name}.png
%ghost %{tbdir}/chrome/app-chrome.manifest
%ghost %{tbdir}/components/compreg.dat
%ghost %{tbdir}/components/xpti.dat
%{tbdir}
%if %{xpi}
%dir %{tbextdir}
%endif
%config(noreplace) %{_sysconfdir}/thunderbird.cfg
# Mandriva menu
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
# other icons
%if %{official_branding}
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
%{_datadir}/icons/hicolor/24x24/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_datadir}/icons/hicolor/256x256/apps/%{name}.png
%else
%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
%endif
# enigmail
%exclude %{tbextdir}/%{enigmail_id}

%files enigmail
%defattr(-,root,root)
%{tbextdir}/%{enigmail_id}

%files -n nsinstall
%defattr(-,root,root)
%{_bindir}/nsinstall

%if %{build_bundled_lightning}
%files lightning
%defattr(-,root,root)
%{tbextdir}/calendar-timezones@mozilla.org
%{tbextdir}/{a62ef8ec-5fdc-40c2-873c-223b8a6925cc}
%{tbextdir}/{e2fda1a4-762b-4020-b5ad-a41df1933103}
%endif


%changelog

* Wed Feb 01 2012 doktor5000 <doktor5000> 0:3.1.18-1.mga1
+ Revision: 203788
- new version 3.1.18
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-59.html
    (.jar files not being treated as executables on MacOS [CVE-2011-3666]
     fixed in 3.1.17)
  o fixes http://www.mozilla.org/security/announce/2012/mfsa2012-01.html
    (Miscellaneous memory safety hazards [(rv:10.0/ 1.9.2.26) [CVE-2012-0443,
      CVE-2012-0442])
  o fixes http://www.mozilla.org/security/announce/2012/mfsa2012-02.html
    (Overly permissive IPv6 literal syntax [CVE-2011-3670])
  o fixes http://www.mozilla.org/security/announce/2012/mfsa2012-04.html
    (Child nodes from nsDOMAttribute still accessible after removal of nodes,
     [CVE-2011-3659])
  o fixes http://www.mozilla.org/security/announce/2012/mfsa2012-07.html
    (Potential Memory Corruption When Decoding Ogg Vorbis files [CVE-2012-0444])
  o fixes http://www.mozilla.org/security/announce/2012/mfsa2012-08.html
    (Crash with malformed embedded XSLT stylesheets [CVE-2012-0449])
- new version 3.1.16
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-46.html
    (loadSubScript unwraps XPCNativeWrapper scope parameter, a malicious page
     could potentially exploit a Thunderbird user who had installed an add-on
     that used loadSubscript in vulnerable ways)
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-47.html
    (Potential cross-site-scripting against sites using Shift-JIS encoding,
     CVE-2011-3648)
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-49.html
    (memory corruption while profiling using Firebug, CVE-2011-3650)
- fixed CVE-2011-3640, untrusted search path vulnerability which might allow
  local users to gain privileges via a Trojan horse pkcs11.txt file in a
  top-level directory (fix-CVE-2011-3640.patch, from upstream)
- new version 3.1.15
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-34.html
    (Protection against fraudulent DigiNotar certificates,
     fixed in thunderbird 3.1.13)
  o fixes http://www.mozilla.org/security/announce/2011/mfsa2011-35.html
    (Additional protection against fraudulent DigiNotar certificates,
    fixed in thunderbird 3.1.14)

  + fwang <fwang>
    - new version 3.1.12

* Fri Apr 29 2011 ahmad <ahmad> 0:3.1.10-1.mga1
+ Revision: 93463
- Update to 3.1.10
- Rediff run-mozilla patch
- Drop an old patch from SOURCES dir

* Fri Mar 25 2011 ahmad <ahmad> 0:3.1.9-11.mga1
+ Revision: 77483
- revert previous commit, gio support doesn't work as it should resulting in http/
  https links handler having to be configured manually for all new and old tb profiles.
  gnomevfs support at least reads the value from gconf settings (which uses www-
  browser by default)

* Mon Mar 21 2011 ahmad <ahmad> 0:3.1.9-10.mga1
+ Revision: 75310
- disable gnomvfs support
- enable gio support
- disable updater as we don't support updating the application this way

* Wed Mar 16 2011 ahmad <ahmad> 0:3.1.9-8.mga1
+ Revision: 72283
- conflict with mozilla-thunderbird-lightning <= 1.3.9

* Fri Mar 11 2011 ahmad <ahmad> 0:3.1.9-7.mga1
+ Revision: 68321
- drop old/uneeded scriptlets that update the destkop-database and hicolor
  icon-cache; they were replaced by rpm filetriggers ages ago

* Fri Mar 11 2011 ahmad <ahmad> 0:3.1.9-6.mga1
+ Revision: 68246
- don't obsolete -lightning here and in the mozilla-thunderbird-lightning src.rpm
  urpmi can't smoothly handle a package obsoleted by two packages

* Fri Mar 11 2011 ahmad <ahmad> 0:3.1.9-5.mga1
+ Revision: 68165
- obsolete the -lightning sub-package that was built from thunderbird src.rpm

* Fri Mar 11 2011 ahmad <ahmad> 0:3.1.9-4.mga1
+ Revision: 68147
- define build_bundled_lightning, and disable it:
 o the thunderbird tarball doesn't have the langpacks for lightning
 o lightning has a separate release schedule (Fedora)

* Wed Mar 09 2011 colin <colin> 0:3.1.9-2.mga1
+ Revision: 66827
- Extract the correct plugin id from lightning extension

* Sat Mar 05 2011 ahmad <ahmad> 0:3.1.9-1.mga1
+ Revision: 64596
- update to 3.1.9

  + dmorgan <dmorgan>
    - obsoletes old package

* Tue Mar 01 2011 ahmad <ahmad> 0:3.1.8-1.mga1
+ Revision: 62332
- update to 3.1.8

* Mon Feb 28 2011 dmorgan <dmorgan> 0:3.1.7-3.mga1
+ Revision: 61407
- Remove remaining mdv macro
- Remove remaining mdv macro
- Fix %%els
- Fix %%else
- Adapt for mageia
- Remove mdv macros
  Adapt for mageia

  + ennael <ennael>
    - imported package mozilla-thunderbird

